<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdkusercreatorcheck.jsp" %>
<%@ page import="com.esko.webcenter.src.root.*"%>
<%@ page import="java.util.*" %>
<%@ page import="sun.misc.BASE64Decoder" %>
<%@ page import="java.util.logging.*" %>
<%@ page import="com.esko.webcenter.log.*" %>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%@ page import="com.esko.util.StringUtils" %>
<%@ page import="com.esko.wcr.ssoapi.instance.SSOInstanceWithUserConf.ConfRole" %>

<%
	// === Start of the main scriplet ===

	// action parameter constants
	final String ACTION_CREATE = "create";
	final String ACTION_MODIFY = "modify";

	String loginID = LoginMgr.getLoginMgr(session).getLoginID(); 
	String userID = LoginMgr.getLoginMgr(session).getLoginUserID();
	boolean isAdmin = LoginMgr.getLoginMgr(session).isAdmin();

	
	// get parameters
	Properties requestParams = SDKUtils.getRequestParams(request, session, application, requestParamsLoginCheck);

	// determine if the data is passed in form of parameters or attributes (from usermgrusersfromfile.jsp)
	// (note "usersfilename" has to be all lowercase, because of RequestUtils.normalizeRequestParams() function)
	boolean asAttr = requestParams.isEmpty() || requestParams.containsKey("usersfilename");

	if (asAttr) {
		requestParams = RequestUtils.normalizeRequestAttrs(request);
	}

	String action = (requestParams.containsKey("action")) ? ((String[])requestParams.get("action"))[0] : null;
	String modUserID = (requestParams.containsKey("userid")) ? ((String[])requestParams.get("userid"))[0] : "";
	String newUserName = (requestParams.containsKey("newusername")) ? ((String[])requestParams.get("newusername"))[0] : "";
	String newPassword = (requestParams.containsKey("newuserpassword")) ? ((String[])requestParams.get("newuserpassword"))[0] : "";
	String companyShortName = (requestParams.containsKey("newusercompanycode")) ? ((String[])requestParams.get("newusercompanycode"))[0] : "";
	String companyName = (requestParams.containsKey("newusercompanyname")) ? ((String[])requestParams.get("newusercompanyname"))[0] : "";
	String locationName = (requestParams.containsKey("newusercompanylocation")) ? ((String[])requestParams.get("newusercompanylocation"))[0] : "";
	String lastName = (requestParams.containsKey("newuserlastname")) ? ((String[])requestParams.get("newuserlastname"))[0] : "";
	String firstName = (requestParams.containsKey("newuserfirstname")) ? ((String[])requestParams.get("newuserfirstname"))[0] : "";
	String isProjectMgr = (requestParams.containsKey("newuserisprojectmanager"))  ? ((String[])requestParams.get("newuserisprojectmanager"))[0] : "";
	String email = (requestParams.containsKey("newuseremail")) ? ((String[])requestParams.get("newuseremail"))[0] : "";
	String phoneNumber = (requestParams.containsKey("newuserphone")) ? ((String[])requestParams.get("newuserphone"))[0] : "";
	String mobileNumber = (requestParams.containsKey("newusermobile")) ? ((String[])requestParams.get("newusermobile"))[0] : "";
	String userFunction = (requestParams.containsKey("newuserfunction")) ? ((String[])requestParams.get("newuserfunction"))[0] : "";
	String forcePswdChange = (requestParams.containsKey("newuserforcepasswordchange")) ? ((String[])requestParams.get("newuserforcepasswordchange"))[0] : "";
	String guaranteedAccess = (requestParams.containsKey("newuserguaranteedaccess")) ? ((String[])requestParams.get("newuserguaranteedaccess"))[0] : "";
	String maxSessions = (requestParams.containsKey("newusernrofsessions"))  ? ((String[])requestParams.get("newusernrofsessions"))[0] : "";
	String prefsFromUserID = (requestParams.containsKey("prefsfromuserid"))  ? ((String[])requestParams.get("prefsfromuserid"))[0] : "";
	String prefsFromUserName = (requestParams.containsKey("prefsfromusername"))  ? ((String[])requestParams.get("prefsfromusername"))[0] : "";
	boolean applyDefaultUserPreferences = (requestParams.containsKey("applydefaultprefs")) && "1".equals(((String[])requestParams.get("applydefaultprefs"))[0]);
	boolean applyVisibilityRules = (requestParams.containsKey("applyvisibilityrules")) && "1".equals(((String[])requestParams.get("applyvisibilityrules"))[0]);
	boolean getNewUserInformation = (requestParams.containsKey("getnewuserinfo")) && "1".equals(((String[])requestParams.get("getnewuserinfo"))[0]);
	boolean isActivateUser = (requestParams.containsKey("activateuser")) && "1".equals(((String[])requestParams.get("activateuser"))[0]);

	// process loaded parameters/attributes
	// ------------------------------------
	if (!isAdmin && (isProjectMgr.length() > 0 || guaranteedAccess.length() > 0 || maxSessions.length() > 0)) {
		String errDetails = "Parameters userid, newuserisprojectmanager, newuserguaranteedaccess, newusernrofsessions cannot be used without administrator rights.";
		out.write(SDKUtils.ShowError(SDKUtils.SDK_NOT_ALLOWED, errDetails));
		checkLogOff(session);
		return;
	}
	if ((newUserName.length() == 0) && (modUserID.length() == 0)) {
		// mandatory attributes check
		out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING, "Either 'newusername' or 'userid' parameter has to be specified."));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.ADMIN) || modUserID.equals(User.ADMIN_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.CADX) || modUserID.equals(User.CADX_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.CLEANUP) || modUserID.equals(User.CLEANUP_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.WORKFLOW) || modUserID.equals(User.WORKFLOW_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}

	
	// remember whether the company short name was specified
	boolean shortNameSpecified = (companyShortName.length() > 0);
	// if only one of the company name and short name (code) was specified, fill the second one with 
	// the same value (none of them can be empty)
	if (companyName.length() == 0) companyName = companyShortName;
	else if (companyShortName.length() == 0) companyShortName = companyName;

	// user company name and location has to be verified to suppress not allowed combinations
	if (((companyShortName.length() == 0) && (locationName.length() > 0)) 
			|| ((companyShortName.length() > 0) && (locationName.length() == 0))) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_COMP_LOC_BOND));
		checkLogOff(session);
		return;
	}

	// process action parameter
	if (action != null && isAdmin)
	{
		action = action.trim();
		if (!action.equalsIgnoreCase(ACTION_CREATE) && !action.equalsIgnoreCase(ACTION_MODIFY)) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Valid values for 'action' parameter are: 'create', 'modify'."));
			checkLogOff(session);
			return;
		}
	}
	else { 
		action = ""; 
	}

	// create a new user and fills his/her attributes
	User newUser = null;
	UserTM userTM = null;
	
	// check if user + company combination already exists in database
	// if so preload the user in order to be able to change only named attributes (update the user)
	// create the EJB 
	userTM = DBTMUtils.findBean(response, session, UserTM.class);
	if (userTM == null) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);
		return;
	}

	if (modUserID.length() > 0) {
		try {
			// ID of user to be modified was specified - use it
			newUser = userTM.findById(loginID, modUserID);
		}
		catch (WebCenterRemoteException ejbEx) {
			LogMgr.getLogger().log(Level.SEVERE, "Error: UserTMBean.findById() Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
	} 
	else {
		try {
			// new user or existing user to be found by name and optionally by short company name
			newUser = userTM.findUserByCompanyNameAndUserName(loginID, companyShortName, newUserName);
		}	
		catch (WebCenterRemoteException ejbEx) {
			LogMgr.getLogger().log(Level.SEVERE, "Error: UserTMBean.findUserByCompanyNameAndUserName() Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
	}
	
	if ((newUser == null) || newUser.isDeleted() || !newUser.isLoaded())
	{
		// specified new user doesn't exist in WCR database or is deleted
		if (action.equalsIgnoreCase(ACTION_MODIFY) || (modUserID.length() > 0))
		{
			// when explicitely set to modify existing WCR user, return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER));
			checkLogOff(session);
			return;
		}
		if (lastName.length() == 0)
		{
			// when creating a new user, newuserlastname parameter is also mandatory...
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING, "newuserlastname parameter must be also specified when creating a new user."));
			checkLogOff(session);
			return;
		}
		newUser = new User();

		// ensure we get a random user key, when a new user is stored in UserDB
		newUser.setUserKey(User.RANDOM_USERKEY_PLACEHOLDER);
		
		// set the user's owner for newly created users
		newUser.setOwnerID(userID);
	}
	else
	{
		// specified new user already exists in WCR database
		if (action.equalsIgnoreCase(ACTION_CREATE))
		{
			// when explicitely set to create a new WCR user, return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_USER_EXISTS));
			checkLogOff(session);
			return;
		}
		
		// if the caller of this SDK is not admin user we have to check whether he/she has rights 
		// to modify the specified existing user!
		if (!isAdmin && !userID.equalsIgnoreCase(newUser.getOwnerID())) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NOT_ALLOWED, "Cannot modify specified user."));
			checkLogOff(session);
	  		return;
		}
	}

	// check if company already exists in database (note the companyName needn't to be checked as the 
	// companyShortName is always filled if at least one of them is specified by the caller)
	if (companyShortName.length() > 0) {
		CompanyTM companyTM = DBTMUtils.findBean(response, session, CompanyTM.class);
		Company company = new Company();
		LocationTM locationTM = DBTMUtils.findBean(response, session, LocationTM.class);
		Location location = new Location();
		Vector<Location> locationList = new Vector<Location>();
		if ((companyTM == null) || (locationTM == null)) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
			checkLogOff(session);
			return;
		}
		try {
			if (shortNameSpecified) {
				company = companyTM.findByName(loginID, companyShortName);
			} else {
				company = companyTM.findByLegalName(loginID, companyName);
			}
		}
		catch (WebCenterRemoteException ejbEx) 	{
			LogMgr.getLogger().log(Level.SEVERE, "Error: companyTM.findByName Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
		if (!((company == null) || !company.isLoaded())) {

			try {
				// get the location list of given company
				locationList = companyTM.loadLocations(loginID, company.getObjectID());
			}
			catch (WebCenterRemoteException ejbEx) 	{
				LogMgr.getLogger().log(Level.SEVERE, "Error: locationTM.findById Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
		}
		else if(isAdmin){
			// create new company (refered by user) and fills its attributes
			company = new Company();   // for safety
			company.setName(companyShortName);
			company.setLegalName(companyName);
		} else {
			LogMgr.getLogger().log(Level.SEVERE, "Company does not exist");
			out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM,  "Company does not exist"));
			checkLogOff(session);
			return;
		}
		// check if location of company already exists - if not create one
		try {
		  location = locationTM.findByNameAndCompany(loginID, locationName, company.getObjectID());
		}
		catch (WebCenterRemoteException  ejbEx) 	{
			DBTMUtils.processRemoteException(response, session, ejbEx, "locationTM.findByNameAndCompany");
			LogMgr.getLogger().log(Level.SEVERE, "Error: locationTM.findByNameAndCompany Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
		if ((location == null) || !location.isLoaded()) {
			if(isAdmin) {
				// create new location (refered by company of created user) and fills its attributes (name is enough)
				location = new Location();   // for safety
				location.setName(locationName);
				locationList.add(location);
				company.setLocationList(locationList);
			} else {
				LogMgr.getLogger().log(Level.SEVERE, "Location not found for this company");
				out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM,  "Location not found for this company"));
				checkLogOff(session);
				return;

			}
		}
		if (isAdmin && (!company.isLoaded() || !location.isLoaded())) {
			// save the new company into database
		  try {
				company = companyTM.save(loginID, company);
			}
			catch (WebCenterRemoteException ejbEx) 	{
				LogMgr.getLogger().log(Level.SEVERE, "Error: companyTM.save Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}

			// reload the location to get valid location ID
			try {
			  location = locationTM.findByNameAndCompany(loginID, locationName, company.getObjectID());
			}
			catch (WebCenterRemoteException  ejbEx) 	{
				DBTMUtils.processRemoteException(response, session, ejbEx, "locationTM.findByNameAndCompany");
				LogMgr.getLogger().log(Level.SEVERE, "Error: locationTM.findByNameAndCompany Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
		}
		if ((location == null) || !location.isLoaded()) {
			LogMgr.getLogger().log(Level.SEVERE, "Error: Problem with location save");
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
			checkLogOff(session);
			return;
		}
		if(!isAdmin) {
			// Check if we can use this company.
			MgrCompanyVisTM mgrCompanyVis = DBTMUtils.findBean(response, session, MgrCompanyVisTM.class);
			if(mgrCompanyVis == null) {
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
				checkLogOff(session);
				return;
			}
			boolean creatorCanAddToCompany = false;
			
			Vector<MgrCompanyVis> companies = mgrCompanyVis.findByUserID(loginID, userID);
			
			// SDK caller is having full visibility to companies.
			if(companies.isEmpty()) {
				creatorCanAddToCompany = true;
			} else {
				Iterator<MgrCompanyVis> it = companies.iterator();
				while(it.hasNext()) {
					MgrCompanyVis c = it.next();
					if(c.getLocationID().equals(location.getObjectID())) {
						creatorCanAddToCompany = true;
						break;
					}
				}
			}
			
			if(creatorCanAddToCompany) {
				newUser.setLocationID(location.getObjectID());
			} else {
				out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Cannot add user to location "+locationName));
				checkLogOff(session);
				return;
				}
			
		} else {
			newUser.setLocationID(location.getObjectID());
		}
	}
	else {
		// location without a company cannot be saved to database
		
		//JANH it gets here only if company and location are blank. In this case the original values should be held.
		// This way it's not possible to "unassign" company from a user that already has one...
		// ...Solution could be to add parameter that would switch between "insert" and "replace" modes (for all params.).
//		newUser.setLocationID("");
	}

	// save remaining attributes into the instance of User class
	// when editing user, there are cases you don't want to change username - no new username is supplied
	if (newUserName.length() > 0)
		newUser.setName(newUserName);
	
	//30.8.2007 JAMI > store password, but first Base64 Decode it
	if (newPassword.length() > 0)  {
		if (asAttr) {
			newUser.setPassword(newPassword);
		}
		else
		{
			//decode the password using Base64
			BASE64Decoder decoder = new BASE64Decoder();
			byte[] decodedStr = decoder.decodeBuffer(newPassword);
			String decodedPswd = new String(decodedStr);
			//now store it
			newUser.setPassword(decodedPswd);
		}
	}
	
	newUser.setPasswordForcedExpired(forcePswdChange.equalsIgnoreCase("1"));

	if (lastName.length() > 0) newUser.setLastName(lastName);
	if (firstName.length() > 0) newUser.setFirstName(firstName);
  	if (isProjectMgr.length() > 0) {
  		// load role list prior to its modification
		if (newUser.getObjectID()!=null && newUser.getObjectID().length()>0 ) 
  		{
			Vector<UserRole> roles = userTM.loadRolesList(loginID, newUser.getObjectID(), newUser.getOwnerID());
			newUser.setRoleList(roles);
		} else {
			// make sure the role list is initialized (loaded)
			newUser.setRoleList(new Vector<UserRole>());
		}
  		
		if (isProjectMgr.equalsIgnoreCase("1")) 
			newUser.addRoleIntoList(RoleDefinition.PROJECT_MANAGER_ID);
	  	else 
	  		newUser.removeRoleFromList(RoleDefinition.PROJECT_MANAGER_ID);
	}
	if (email.length() > 0) newUser.setEmail(email);
	if (phoneNumber.length() > 0) newUser.setPhoneNumber(phoneNumber);
	if (mobileNumber.length() > 0) newUser.setMobileNumber(mobileNumber);
	if (userFunction.length() > 0) newUser.setFunction(userFunction);
	if (guaranteedAccess.length() > 0) newUser.setGuaranteedAccessValue(guaranteedAccess.equalsIgnoreCase("1"));
	
	// set max number of sessions
	if (maxSessions.length() > 0){
		newUser.setMaxSessions(maxSessions);
	} else if (action.equalsIgnoreCase(ACTION_CREATE)){
		newUser.setMaxSessions(User.MAX_SESSION_DEFAULT);
	}

	// activate the user if user is inactive and action is modify
	if (isActivateUser && action.equalsIgnoreCase(ACTION_MODIFY)) {
		newUser.setActive(true);
	}
	
	// save the user into database
	if (newUser != null) {
		  try {
				newUser = userTM.save(loginID, newUser);
			}
			catch (WebCenterRemoteException ejbEx) 	{
				LogMgr.getLogger().log(Level.SEVERE, "Error: UserTM.save Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
	}
	
	// Reload the user from the DB so the password in the User object is encrypted
	newUser = userTM.findById(loginID, newUser.getObjectID());

	
	if (newUser == null) {
		String errMsg = "Problem during creation/modification of user: " + (modUserID.length() > 0 ? modUserID : newUserName);
		LogMgr.getLogger().log(Level.SEVERE, "Error: " + errMsg);
		out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER, errMsg));
		checkLogOff(session);
  		return;
	}
	
	try {
		User prefsFromUser = null;
		// check if there is an explicitly specified user from whome to apply preferences (settings)
		if ((prefsFromUserID.length() > 0) || (prefsFromUserName.length() > 0)) {
			// load the user from whome the preferences should be copied
			StringBuffer errorMsg = new StringBuffer();
			prefsFromUser = SDKUtils.getUserByIDOrName(loginID, prefsFromUserID, prefsFromUserName, errorMsg, userTM);
			if (prefsFromUser == null) {
				String detailMsg = "\nDetails: Cannot load user with ID/name: " + (prefsFromUserID.length() > 0 ? prefsFromUserID : prefsFromUserName);
				out.write(errorMsg.toString() + detailMsg);
				checkLogOff(session);
				return;
			}
			prefsFromUserID = prefsFromUser.getObjectID();
			// if the caller of this SDK is not admin user we have to check whether he/she has rights 
			// to apply settings from selected template user!
			if (!isAdmin && StringUtils.checkForValue(prefsFromUserID)) {
				// user preferences/settings can be applied only from an owned user if the caller is not an admin
				if (!userID.equalsIgnoreCase(prefsFromUser.getOwnerID())) {
					out.write(SDKUtils.ShowError(SDKUtils.SDK_NOT_ALLOWED, "Cannot apply user settings from specified template user."));
					checkLogOff(session);
			  		return;
				}
			}
		} else if (applyDefaultUserPreferences) {
			// we don't want/need to verify correctness of template user for non-admin callers here as UI to set
			// the default template user takes care of it...
			UserProfileTM userProfileTM = DBTMUtils.findBean(response, session, UserProfileTM.class);
			prefsFromUserID = userProfileTM.getDefaultUserId(loginID, ProfileFields.WC_DEFAULT_USER_TEMPLATE);


			if(StringUtils.checkForValue(prefsFromUserID)) {
				StringBuffer errorMsg = new StringBuffer();
				prefsFromUser = SDKUtils.getUserByID(loginID, prefsFromUserID, errorMsg, userTM);
				if (prefsFromUser == null) {
					String detailMsg = "\nDetails: Cannot load user with ID: " + prefsFromUserID;
					out.write(errorMsg.toString() + detailMsg);
					checkLogOff(session);
					return;
				}
			}
			Enumeration<String> params = request.getParameterNames();
			boolean hasSSOParams = false;
			// Check if the request contains SSO parameters
			while(params.hasMoreElements()) {
				if(params.nextElement().indexOf("sso") == 0) {
					hasSSOParams = true;
					break;
				}
			}
			if(hasSSOParams) {
				SSOWebUtil.processUserConfiguraton(newUser.getObjectID(), request, ConfRole.ADMIN);
			}
		}
		
		if (StringUtils.checkForValue(prefsFromUserID)) {
			// get the system defaults - we will need them later
			ProfileDefault profileDefault = ProfileMgr.getInstance().getProfileDefault(session.getServletContext());
			Collection<String> userToIds = new ArrayList(1);
			userToIds.add(newUser.getObjectID());

			// set what preferences/settings to apply
			Map<String, Boolean> appliesMap = new HashMap<String, Boolean>();
			appliesMap.put(UserTM.APPLY_LANG, true);
			appliesMap.put(UserTM.APPLY_MENU, true);
			appliesMap.put(UserTM.APPLY_HOME_PAGE, true);
			appliesMap.put(UserTM.APPLY_FORMATS, isAdmin);   // (download formats can be set only by admins)
			appliesMap.put(UserTM.APPLY_GROUPS, isAdmin);
			appliesMap.put(UserTM.APPLY_UNITS, true);	
			appliesMap.put(UserTM.APPLY_START_PAGE, true);
			appliesMap.put(UserTM.APPLY_VIEWER_PREFERENCES, true);
			appliesMap.put(UserTM.APPLY_COLLADA_VIEWER_PREFERENCES, true);
			appliesMap.put(UserTM.APPLY_WORKFLOW_EDITOR_PREFERENCES, true);
			appliesMap.put(UserTM.APPLY_DOCUMENT_UPLOAD_PREFERENCES, true);
			appliesMap.put(UserTM.APPLY_ARTIOS_CAD_PREFERENCES, true);
			appliesMap.put(UserTM.APPLY_OTHER_PREFERENCES, true);
			appliesMap.put(UserTM.APPLY_DEACTIVATION_PREFERENCES, true);
			
			// do apply the preferences
			userTM.multipleApplyUserPreferences(loginID, prefsFromUserID, userToIds, appliesMap, profileDefault);
			
			// process visibility of companies/locations and groups
			// this is applicable only for PMs!
			if (applyVisibilityRules) {
				try {
					if (!newUser.rolesValid()) {
						// load roles of the user to be able to find out he/she is PM or not
						Vector<UserRole> roles = userTM.loadRolesList(loginID, newUser.getObjectID(), newUser.getOwnerID());
						newUser.setRoleList(roles);
					}
					if (!prefsFromUser.rolesValid()) {
						// load roles of the user to be able to find out he/she is PM or not
						Vector<UserRole> roles = userTM.loadRolesList(loginID, prefsFromUserID, prefsFromUser.getOwnerID());
						prefsFromUser.setRoleList(roles);
					}
					// apply the visibility rules only if both users are PMs (full or with limited visibility)
					if (!newUser.isProjectManager() || !prefsFromUser.isProjectManager()) {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_CANNOT_APPLY_TEMPL_USER, "Companies and groups visibility rules can be applied only among PM users."));
						checkLogOff(session);
				  		return;
					}
					// we are good to go - first handle the company/location visibility as the type of PM 
					// is controlled by that
					MgrCompanyVisTM companyVisTM = DBTMUtils.findBean(response, session, MgrCompanyVisTM.class);
					if (companyVisTM == null) {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
						checkLogOff(session);
				  		return;
					}
					// load list of companies/locations visible to the template user
					Vector<MgrCompanyVis> compVisList = companyVisTM.findByUserID(loginID, prefsFromUserID);
					// apply the list of visible companies/locations to the created/modified user
					Vector<String> visLocIDList = MgrCompanyVis.getLocationIDsFromVector(compVisList);
					CompanyVisUtils.saveChangesForOneUser(response, session, newUser, visLocIDList, null, 0);

					// now add the group visibility (note it's ignored if company visibility is not set == user
					// is NOT PM with limited visibility)
					MgrGroupVisTM groupVisTM = DBTMUtils.findBean(response, session, MgrGroupVisTM.class);
					if (groupVisTM == null) {
						out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
						checkLogOff(session);
				  		return;
					}
					// load list of groups visible to the template user
					Vector<MgrGroupVis> groupVisList = groupVisTM.findByUserID(loginID, prefsFromUserID);
					// apply the list of visible groups to the created/modified user
					Vector<String> visGroupIDList = MgrGroupVis.getGroupIDsFromVector(groupVisList);
					GroupVisUtils.saveChangesForOneUser(response, session, newUser, visGroupIDList, null, 0);
				} catch (WebCenterRemoteException ex) {
					out.write(SDKUtils.ShowError(SDKUtils.SDK_CANNOT_APPLY_TEMPL_USER, "Cannot apply companies and/or groups visibility rules.", ex));
					checkLogOff(session);
			  		return;
				}
			}
		}
	} catch (WebCenterRemoteException ex) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_CANNOT_APPLY_TEMPL_USER, ex));
		checkLogOff(session);
  		return;
	}
	
	
	request.setAttribute("wasUserCreated", "1");   // needed for proper function of usermgrusersfromfile.jsp
	
	// output of the SDK call
	
	if(getNewUserInformation) {
		
		StringBuffer newUserInfo = new StringBuffer();
		
		newUserInfo.append("<new_user_info>");
			newUserInfo.append("<userID>" + newUser.getObjectID() + "</userID>");
			newUserInfo.append("<userName>" + newUser.getName() + "</userName>");
			newUserInfo.append("<firstName>" + newUser.getFirstName() + "</firstName>");
			newUserInfo.append("<lastName>" + newUser.getLastName() + "</lastName>");
			newUserInfo.append("<email>" + newUser.getEmail() + "</email>");
			newUserInfo.append("<isActive>" + newUser.isActiveUser() + "</isActive>");
		newUserInfo.append("</new_user_info>");
		
		out.write(newUserInfo.toString());
		
	} else {
		out.write("<userID>" + newUser.getObjectID() + "</userID>");
	}
	
	checkLogOff(session);
%>
